X.509 module

## Data Structures

struct | mbedtls_x509_time
struct | mbedtls_x509_crl_entry
struct | mbedtls_x509_crl
struct | mbedtls_x509_crt
struct | mbedtls_x509_crt_profile
struct | mbedtls_x509write_cert
struct | mbedtls_x509_csr
struct | mbedtls_x509write_csr

## Macros

#define | MBEDTLS_X509_MAX_INTERMEDIATE_CA 8

## Functions

int | mbedtls_dhm_parse_dhm (mbedtls_dhm_context *dhm, const unsigned char *dhmin, size_t dhminlen)
| This function parses DHM parameters in PEM or DER format. More...
int | mbedtls_dhm_parse_dhmfile (mbedtls_dhm_context *dhm, const char *path)
| This function loads and parses DHM parameters from a file. More...

## X509 Error codes

#define | MBEDTLS_ERR_X509_FEATURE_UNAVAILABLE -0x2080
#define | MBEDTLS_ERR_X509_UNKNOWN_OID -0x2100
#define | MBEDTLS_ERR_X509_INVALID_FORMAT -0x2180
#define | MBEDTLS_ERR_X509_INVALID_VERSION -0x2200
#define | MBEDTLS_ERR_X509_INVALID_SERIAL -0x2280
#define | MBEDTLS_ERR_X509_INVALID_ALG -0x2300
#define | MBEDTLS_ERR_X509_INVALID_NAME -0x2380
#define | MBEDTLS_ERR_X509_INVALID_DATE -0x2400
#define | MBEDTLS_ERR_X509_INVALID_SIGNATURE -0x2480
#define | MBEDTLS_ERR_X509_INVALID_EXTENSIONS -0x2500
#define | MBEDTLS_ERR_X509_UNKNOWN_VERSION -0x2580
#define | MBEDTLS_ERR_X509_UNKNOWN_SIG_ALG -0x2600
#define | MBEDTLS_ERR_X509_SIG_MISMATCH -0x2680
#define | MBEDTLS_ERR_X509_CERT_VERIFY_FAILED -0x2700
#define | MBEDTLS_ERR_X509_CERT_UNKNOWN_FORMAT -0x2780
#define | MBEDTLS_ERR_X509_BAD_INPUT_DATA -0x2800
#define | MBEDTLS_ERR_X509_ALLOC_FAILED -0x2880
#define | MBEDTLS_ERR_X509_FILE_IO_ERROR -0x2900
#define | MBEDTLS_ERR_X509_BUFFER_TOO_SMALL -0x2980
#define | MBEDTLS_ERR_X509_FATAL_ERROR -0x3000

## X509 Verify codes

#define | MBEDTLS_X509_BADCERT_EXPIRED 0x01
#define | MBEDTLS_X509_BADCERT_REVOKED 0x02
#define | MBEDTLS_X509_BADCERT_CN_MISMATCH 0x04
#define | MBEDTLS_X509_BADCERT_NOT_TRUSTED 0x08
#define | MBEDTLS_X509_BADCRL_NOT_TRUSTED 0x10
#define | MBEDTLS_X509_BADCRL_EXPIRED 0x20
#define | MBEDTLS_X509_BADCERT_MISSING 0x40
#define | MBEDTLS_X509_BADCERT_SKIP_VERIFY 0x80
#define | MBEDTLS_X509_BADCERT_OTHER 0x0100
#define | MBEDTLS_X509_BADCERT_FUTURE 0x0200
#define | MBEDTLS_X509_BADCRL_FUTURE 0x0400
#define | MBEDTLS_X509_BADCERT_KEY_USAGE 0x0800
#define | MBEDTLS_X509_BADCERT_EXT_KEY_USAGE 0x1000
#define | MBEDTLS_X509_BADCERT_NS_CERT_TYPE 0x2000
#define | MBEDTLS_X509_BADCERT_BAD_MD 0x4000
#define | MBEDTLS_X509_BADCERT_BAD_PK 0x8000
#define | MBEDTLS_X509_BADCERT_BAD_KEY 0x010000
#define | MBEDTLS_X509_BADCRL_BAD_MD 0x020000
#define | MBEDTLS_X509_BADCRL_BAD_PK 0x040000
#define | MBEDTLS_X509_BADCRL_BAD_KEY 0x080000

## Structures for parsing X.509 certificates, CRLs and CSRs

typedef mbedtls_asn1_buf | mbedtls_x509_buf
typedef mbedtls_asn1_bitstring | mbedtls_x509_bitstring
typedef mbedtls_asn1_named_data | mbedtls_x509_name
typedef mbedtls_asn1_sequence | mbedtls_x509_sequence
typedef struct mbedtls_x509_time | mbedtls_x509_time

## Structures and functions for parsing CRLs

typedef struct mbedtls_x509_crl_entry | mbedtls_x509_crl_entry
typedef struct mbedtls_x509_crl | mbedtls_x509_crl
int | mbedtls_x509_crl_parse_der (mbedtls_x509_crl *chain, const unsigned char *buf, size_t buflen)
| Parse a DER-encoded CRL and append it to the chained list. More...
int | mbedtls_x509_crl_parse (mbedtls_x509_crl *chain, const unsigned char *buf, size_t buflen)
| Parse one or more CRLs and append them to the chained list. More...
int | mbedtls_x509_crl_parse_file (mbedtls_x509_crl *chain, const char *path)
| Load one or more CRLs and append them to the chained list. More...
int | mbedtls_x509_crl_info (char *buf, size_t size, const char *prefix, const mbedtls_x509_crl *crl)
| Returns an informational string about the CRL. More...
void | mbedtls_x509_crl_init (mbedtls_x509_crl *crl)
| Initialize a CRL (chain) More...
void | mbedtls_x509_crl_free (mbedtls_x509_crl *crl)
| Unallocate all CRL data. More...

## Structures and functions for parsing and writing X.509 certificates

typedef struct mbedtls_x509_crt | mbedtls_x509_crt
typedef struct mbedtls_x509write_cert | mbedtls_x509write_cert
const mbedtls_x509_crt_profile | mbedtls_x509_crt_profile_default
const mbedtls_x509_crt_profile | mbedtls_x509_crt_profile_next
const mbedtls_x509_crt_profile | mbedtls_x509_crt_profile_suiteb
int | mbedtls_x509_crt_parse_der (mbedtls_x509_crt *chain, const unsigned char *buf, size_t buflen)
| Parse a single DER formatted certificate and add it to the chained list. More...
int | mbedtls_x509_crt_parse (mbedtls_x509_crt *chain, const unsigned char *buf, size_t buflen)
| Parse one or more certificates and add them to the chained list. Parses permissively. If some certificates can be parsed, the result is the number of failed certificates it encountered. If none complete correctly, the first error is returned. More...
int | mbedtls_x509_crt_parse_file (mbedtls_x509_crt *chain, const char *path)
| Load one or more certificates and add them to the chained list. Parses permissively. If some certificates can be parsed, the result is the number of failed certificates it encountered. If none complete correctly, the first error is returned. More...
int | mbedtls_x509_crt_parse_path (mbedtls_x509_crt *chain, const char *path)
| Load one or more certificate files from a path and add them to the chained list. Parses permissively. If some certificates can be parsed, the result is the number of failed certificates it encountered. If none complete correctly, the first error is returned. More...
int | mbedtls_x509_crt_info (char *buf, size_t size, const char *prefix, const mbedtls_x509_crt *crt)
| Returns an informational string about the certificate. More...
int | mbedtls_x509_crt_verify_info (char *buf, size_t size, const char *prefix, uint32_t flags)
| Returns an informational string about the verification status of a certificate. More...
int | mbedtls_x509_crt_verify (mbedtls_x509_crt *crt, mbedtls_x509_crt *trust_ca, mbedtls_x509_crl *ca_crl, const char *cn, uint32_t *flags, int(*f_vrfy)(void *, mbedtls_x509_crt *, int, uint32_t *), void *p_vrfy)
| Verify the certificate signature. More...
int | mbedtls_x509_crt_verify_with_profile (mbedtls_x509_crt *crt, mbedtls_x509_crt *trust_ca, mbedtls_x509_crl *ca_crl, const mbedtls_x509_crt_profile *profile, const char *cn, uint32_t *flags, int(*f_vrfy)(void *, mbedtls_x509_crt *, int, uint32_t *), void *p_vrfy)
| Verify the certificate signature according to profile. More...
int | mbedtls_x509_crt_check_key_usage (const mbedtls_x509_crt *crt, unsigned int usage)
| Check usage of certificate against keyUsage extension. More...
int | mbedtls_x509_crt_check_extended_key_usage (const mbedtls_x509_crt *crt, const char *usage_oid, size_t usage_len)
| Check usage of certificate against extendedKeyUsage. More...
int | mbedtls_x509_crt_is_revoked (const mbedtls_x509_crt *crt, const mbedtls_x509_crl *crl)
| Verify the certificate revocation status. More...
void | mbedtls_x509_crt_init (mbedtls_x509_crt *crt)
| Initialize a certificate (chain) More...
void | mbedtls_x509_crt_free (mbedtls_x509_crt *crt)
| Unallocate all certificate data. More...
#define | MBEDTLS_X509_ID_FLAG(id) ( 1 << ( id - 1 ) )
#define | MBEDTLS_X509_CRT_VERSION_1 0
#define | MBEDTLS_X509_CRT_VERSION_2 1
#define | MBEDTLS_X509_CRT_VERSION_3 2
#define | MBEDTLS_X509_RFC5280_MAX_SERIAL_LEN 32
#define | MBEDTLS_X509_RFC5280_UTC_TIME_LEN 15
#define | MBEDTLS_X509_MAX_FILE_PATH_LEN 512

## Structures and functions for X.509 Certificate Signing Requests (CSR)

typedef struct mbedtls_x509_csr | mbedtls_x509_csr
typedef struct mbedtls_x509write_csr | mbedtls_x509write_csr
int | mbedtls_x509_csr_parse_der (mbedtls_x509_csr *csr, const unsigned char *buf, size_t buflen)
| Load a Certificate Signing Request (CSR) in DER format. More...
int | mbedtls_x509_csr_parse (mbedtls_x509_csr *csr, const unsigned char *buf, size_t buflen)
| Load a Certificate Signing Request (CSR), DER or PEM format. More...
int | mbedtls_x509_csr_parse_file (mbedtls_x509_csr *csr, const char *path)
| Load a Certificate Signing Request (CSR) More...
int | mbedtls_x509_csr_info (char *buf, size_t size, const char *prefix, const mbedtls_x509_csr *csr)
| Returns an informational string about the CSR. More...
void | mbedtls_x509_csr_init (mbedtls_x509_csr *csr)
| Initialize a CSR. More...
void | mbedtls_x509_csr_free (mbedtls_x509_csr *csr)
| Unallocate all CSR data. More...

## Detailed Description

The X.509 module provides X.509 support for reading, writing and verification of certificates. In summary:

- X.509 certificate (CRT) reading (see `mbedtls_x509_crt_parse()`, `mbedtls_x509_crt_parse_der()`, `mbedtls_x509_crt_parse_file()`).
- X.509 certificate revocation list (CRL) reading (see `mbedtls_x509_crl_parse()`, `mbedtls_x509_crl_parse_der()`, and `mbedtls_x509_crl_parse_file()`).
- X.509 certificate signature verification (see `mbedtls_x509_crt_verify()` and `mbedtls_x509_crt_verify_with_profile()`.
- X.509 certificate writing and certificate request writing (see `mbedtls_x509write_crt_der()` and `mbedtls_x509write_csr_der()`).

This module can be used to build a certificate authority (CA) chain and verify its signature. It is also used to generate Certificate Signing Requests and X.509 certificates just as a CA would do.

## Macro Definition Documentation

## MBEDTLS_ERR_X509_ALLOC_FAILED

#define MBEDTLS_ERR_X509_ALLOC_FAILED -0x2880

Allocation of memory failed.

Definition at line 77 of file x509.h.

## MBEDTLS_ERR_X509_BAD_INPUT_DATA

#define MBEDTLS_ERR_X509_BAD_INPUT_DATA -0x2800

Input invalid.

Definition at line 76 of file x509.h.

## MBEDTLS_ERR_X509_BUFFER_TOO_SMALL

#define MBEDTLS_ERR_X509_BUFFER_TOO_SMALL -0x2980

Destination buffer is too small.

Definition at line 79 of file x509.h.

## MBEDTLS_ERR_X509_CERT_UNKNOWN_FORMAT

#define MBEDTLS_ERR_X509_CERT_UNKNOWN_FORMAT -0x2780

Format not recognized as DER or PEM.

Definition at line 75 of file x509.h.

## MBEDTLS_ERR_X509_CERT_VERIFY_FAILED

#define MBEDTLS_ERR_X509_CERT_VERIFY_FAILED -0x2700

Certificate verification failed, e.g. CRL, CA or signature check failed.

Definition at line 74 of file x509.h.

## MBEDTLS_ERR_X509_FATAL_ERROR

#define MBEDTLS_ERR_X509_FATAL_ERROR -0x3000

A fatal error occured, eg the chain is too long or the vrfy callback failed.

Definition at line 80 of file x509.h.

## MBEDTLS_ERR_X509_FEATURE_UNAVAILABLE

#define MBEDTLS_ERR_X509_FEATURE_UNAVAILABLE -0x2080

Unavailable feature, e.g. RSA hashing/encryption combination.

Definition at line 61 of file x509.h.

## MBEDTLS_ERR_X509_FILE_IO_ERROR

#define MBEDTLS_ERR_X509_FILE_IO_ERROR -0x2900

Read/write of file failed.

Definition at line 78 of file x509.h.

## MBEDTLS_ERR_X509_INVALID_ALG

#define MBEDTLS_ERR_X509_INVALID_ALG -0x2300

The algorithm tag or value is invalid.

Definition at line 66 of file x509.h.

## MBEDTLS_ERR_X509_INVALID_DATE

#define MBEDTLS_ERR_X509_INVALID_DATE -0x2400

The date tag or value is invalid.

Definition at line 68 of file x509.h.

## MBEDTLS_ERR_X509_INVALID_EXTENSIONS

#define MBEDTLS_ERR_X509_INVALID_EXTENSIONS -0x2500

The extension tag or value is invalid.

Definition at line 70 of file x509.h.

## MBEDTLS_ERR_X509_INVALID_FORMAT

#define MBEDTLS_ERR_X509_INVALID_FORMAT -0x2180

The CRT/CRL/CSR format is invalid, e.g. different type expected.

Definition at line 63 of file x509.h.

## MBEDTLS_ERR_X509_INVALID_NAME

#define MBEDTLS_ERR_X509_INVALID_NAME -0x2380

The name tag or value is invalid.

Definition at line 67 of file x509.h.

## MBEDTLS_ERR_X509_INVALID_SERIAL

#define MBEDTLS_ERR_X509_INVALID_SERIAL -0x2280

The serial tag or value is invalid.

Definition at line 65 of file x509.h.

## MBEDTLS_ERR_X509_INVALID_SIGNATURE

#define MBEDTLS_ERR_X509_INVALID_SIGNATURE -0x2480

The signature tag or value invalid.

Definition at line 69 of file x509.h.

## MBEDTLS_ERR_X509_INVALID_VERSION

#define MBEDTLS_ERR_X509_INVALID_VERSION -0x2200

The CRT/CRL/CSR version element is invalid.

Definition at line 64 of file x509.h.

## MBEDTLS_ERR_X509_SIG_MISMATCH

#define MBEDTLS_ERR_X509_SIG_MISMATCH -0x2680

Signature algorithms do not match. (see `mbedtls_x509_crt` sig_oid)

Definition at line 73 of file x509.h.

## MBEDTLS_ERR_X509_UNKNOWN_OID

#define MBEDTLS_ERR_X509_UNKNOWN_OID -0x2100

Requested OID is unknown.

Definition at line 62 of file x509.h.

## MBEDTLS_ERR_X509_UNKNOWN_SIG_ALG

#define MBEDTLS_ERR_X509_UNKNOWN_SIG_ALG -0x2600

Signature algorithm (oid) is unsupported.

Definition at line 72 of file x509.h.

## MBEDTLS_ERR_X509_UNKNOWN_VERSION

#define MBEDTLS_ERR_X509_UNKNOWN_VERSION -0x2580

CRT/CRL/CSR has an unsupported version number.

Definition at line 71 of file x509.h.

## MBEDTLS_X509_BADCERT_BAD_KEY

#define MBEDTLS_X509_BADCERT_BAD_KEY 0x010000

The certificate is signed with an unacceptable key (eg bad curve, RSA too short).

Definition at line 104 of file x509.h.

## MBEDTLS_X509_BADCERT_BAD_MD

#define MBEDTLS_X509_BADCERT_BAD_MD 0x4000

The certificate is signed with an unacceptable hash.

Definition at line 102 of file x509.h.

## MBEDTLS_X509_BADCERT_BAD_PK

#define MBEDTLS_X509_BADCERT_BAD_PK 0x8000

The certificate is signed with an unacceptable PK alg (eg RSA vs ECDSA).

Definition at line 103 of file x509.h.

## MBEDTLS_X509_BADCERT_CN_MISMATCH

#define MBEDTLS_X509_BADCERT_CN_MISMATCH 0x04

The certificate Common Name (CN) does not match with the expected CN.

Definition at line 90 of file x509.h.

## MBEDTLS_X509_BADCERT_EXPIRED

#define MBEDTLS_X509_BADCERT_EXPIRED 0x01

The certificate validity has expired.

Definition at line 88 of file x509.h.

## MBEDTLS_X509_BADCERT_EXT_KEY_USAGE

#define MBEDTLS_X509_BADCERT_EXT_KEY_USAGE 0x1000

Usage does not match the extendedKeyUsage extension.

Definition at line 100 of file x509.h.

## MBEDTLS_X509_BADCERT_FUTURE

#define MBEDTLS_X509_BADCERT_FUTURE 0x0200

The certificate validity starts in the future.

Definition at line 97 of file x509.h.

## MBEDTLS_X509_BADCERT_KEY_USAGE

#define MBEDTLS_X509_BADCERT_KEY_USAGE 0x0800

Usage does not match the keyUsage extension.

Definition at line 99 of file x509.h.

## MBEDTLS_X509_BADCERT_MISSING

#define MBEDTLS_X509_BADCERT_MISSING 0x40

Certificate was missing.

Definition at line 94 of file x509.h.

## MBEDTLS_X509_BADCERT_NOT_TRUSTED

#define MBEDTLS_X509_BADCERT_NOT_TRUSTED 0x08

The certificate is not correctly signed by the trusted CA.

Definition at line 91 of file x509.h.

## MBEDTLS_X509_BADCERT_NS_CERT_TYPE

#define MBEDTLS_X509_BADCERT_NS_CERT_TYPE 0x2000

Usage does not match the nsCertType extension.

Definition at line 101 of file x509.h.

## MBEDTLS_X509_BADCERT_OTHER

#define MBEDTLS_X509_BADCERT_OTHER 0x0100

Other reason (can be used by verify callback)

Definition at line 96 of file x509.h.

## MBEDTLS_X509_BADCERT_REVOKED

#define MBEDTLS_X509_BADCERT_REVOKED 0x02

The certificate has been revoked (is on a CRL).

Definition at line 89 of file x509.h.

## MBEDTLS_X509_BADCERT_SKIP_VERIFY

#define MBEDTLS_X509_BADCERT_SKIP_VERIFY 0x80

Certificate verification was skipped.

Definition at line 95 of file x509.h.

## MBEDTLS_X509_BADCRL_BAD_KEY

#define MBEDTLS_X509_BADCRL_BAD_KEY 0x080000

The CRL is signed with an unacceptable key (eg bad curve, RSA too short).

Definition at line 107 of file x509.h.

## MBEDTLS_X509_BADCRL_BAD_MD

#define MBEDTLS_X509_BADCRL_BAD_MD 0x020000

The CRL is signed with an unacceptable hash.

Definition at line 105 of file x509.h.

## MBEDTLS_X509_BADCRL_BAD_PK

#define MBEDTLS_X509_BADCRL_BAD_PK 0x040000

The CRL is signed with an unacceptable PK alg (eg RSA vs ECDSA).

Definition at line 106 of file x509.h.

## MBEDTLS_X509_BADCRL_EXPIRED

#define MBEDTLS_X509_BADCRL_EXPIRED 0x20

The CRL is expired.

Definition at line 93 of file x509.h.

## MBEDTLS_X509_BADCRL_FUTURE

#define MBEDTLS_X509_BADCRL_FUTURE 0x0400

The CRL is from the future

Definition at line 98 of file x509.h.

## MBEDTLS_X509_BADCRL_NOT_TRUSTED

#define MBEDTLS_X509_BADCRL_NOT_TRUSTED 0x10

The CRL is not correctly signed by the trusted CA.

Definition at line 92 of file x509.h.

## MBEDTLS_X509_CRT_VERSION_1

#define MBEDTLS_X509_CRT_VERSION_1 0

Definition at line 117 of file x509_crt.h.

## MBEDTLS_X509_CRT_VERSION_2

#define MBEDTLS_X509_CRT_VERSION_2 1

Definition at line 118 of file x509_crt.h.

## MBEDTLS_X509_CRT_VERSION_3

#define MBEDTLS_X509_CRT_VERSION_3 2

Definition at line 119 of file x509_crt.h.

## MBEDTLS_X509_ID_FLAG

#define MBEDTLS_X509_ID_FLAG | ( |  | id | ) | ( 1 << ( id - 1 ) )

Build flag from an algorithm/curve identifier (pk, md, ecp) Since 0 is always XXX_NONE, ignore it.

Definition at line 101 of file x509_crt.h.

## MBEDTLS_X509_MAX_FILE_PATH_LEN

#define MBEDTLS_X509_MAX_FILE_PATH_LEN 512

Definition at line 125 of file x509_crt.h.

## MBEDTLS_X509_MAX_INTERMEDIATE_CA

#define MBEDTLS_X509_MAX_INTERMEDIATE_CA 8

Maximum number of intermediate CAs in a verification chain. That is, maximum length of the chain, excluding the end-entity certificate and the trusted root certificate.

Set this to a low value to prevent an adversary from making you waste resources verifying an overlong certificate chain.

Definition at line 54 of file x509.h.

## MBEDTLS_X509_RFC5280_MAX_SERIAL_LEN

#define MBEDTLS_X509_RFC5280_MAX_SERIAL_LEN 32

Definition at line 121 of file x509_crt.h.

## MBEDTLS_X509_RFC5280_UTC_TIME_LEN

#define MBEDTLS_X509_RFC5280_UTC_TIME_LEN 15

Definition at line 122 of file x509_crt.h.

## Typedef Documentation

## mbedtls_x509_bitstring

typedef mbedtls_asn1_bitstring mbedtls_x509_bitstring

Container for ASN1 bit strings.

Definition at line 194 of file x509.h.

## mbedtls_x509_buf

typedef mbedtls_asn1_buf mbedtls_x509_buf

Type-length-value structure that allows for ASN1 using DER.

Definition at line 189 of file x509.h.

## mbedtls_x509_crl

typedef struct mbedtls_x509_crl mbedtls_x509_crl

Certificate revocation list structure. Every CRL may have multiple entries.

## mbedtls_x509_crl_entry

typedef struct mbedtls_x509_crl_entry mbedtls_x509_crl_entry

Certificate revocation list entry. Contains the CA-specific serial numbers and revocation dates.

## mbedtls_x509_crt

typedef struct mbedtls_x509_crt mbedtls_x509_crt

Container for an X.509 certificate. The certificate may be chained.

## mbedtls_x509_csr

typedef struct mbedtls_x509_csr mbedtls_x509_csr

Certificate Signing Request (CSR) structure.

## mbedtls_x509_name

typedef mbedtls_asn1_named_data mbedtls_x509_name

Container for ASN1 named information objects. It allows for Relative Distinguished Names (e.g. cn=localhost,ou=code,etc.).

Definition at line 200 of file x509.h.

## mbedtls_x509_sequence

typedef mbedtls_asn1_sequence mbedtls_x509_sequence

Container for a sequence of ASN.1 items

Definition at line 205 of file x509.h.

## mbedtls_x509_time

typedef struct mbedtls_x509_time mbedtls_x509_time

Container for date and time (precision in seconds).

## mbedtls_x509write_cert

typedef struct mbedtls_x509write_cert mbedtls_x509write_cert

Container for writing a certificate (CRT)

## mbedtls_x509write_csr

typedef struct mbedtls_x509write_csr mbedtls_x509write_csr

Container for writing a CSR

## Function Documentation

## mbedtls_dhm_parse_dhm()

int mbedtls_dhm_parse_dhm | ( | mbedtls_dhm_context * | dhm,
|  | const unsigned char * | dhmin,
|  | size_t | dhminlen
| ) |  |

This function parses DHM parameters in PEM or DER format.

Parameters

  dhm | The DHM context to initialize.
  dhmin | The input buffer.
  dhminlen | The size of the buffer, including the terminating null Byte for PEM data.

Returns
  `0` on success, or a specific DHM or PEM error code on failure.

## mbedtls_dhm_parse_dhmfile()

int mbedtls_dhm_parse_dhmfile | ( | mbedtls_dhm_context * | dhm,
|  | const char * | path
| ) |  |

This function loads and parses DHM parameters from a file.

Parameters

  dhm | The DHM context to load the parameters to.
  path | The filename to read the DHM parameters from.

Returns
  `0` on success, or a specific DHM or PEM error code on failure.

## mbedtls_x509_crl_free()

void mbedtls_x509_crl_free | ( | mbedtls_x509_crl * | crl | ) |

Unallocate all CRL data.

Parameters

  crl | CRL chain to free

## mbedtls_x509_crl_info()

int mbedtls_x509_crl_info | ( | char * | buf,
|  | size_t | size,
|  | const char * | prefix,
|  | const mbedtls_x509_crl * | crl
| ) |  |

Returns an informational string about the CRL.

Parameters

  buf | Buffer to write to
  size | Maximum size of buffer
  prefix | A line prefix
  crl | The X509 CRL to represent

Returns
  The length of the string written (not including the terminated nul byte), or a negative error code.

## mbedtls_x509_crl_init()

void mbedtls_x509_crl_init | ( | mbedtls_x509_crl * | crl | ) |

Initialize a CRL (chain)

Parameters

  crl | CRL chain to initialize

## mbedtls_x509_crl_parse()

int mbedtls_x509_crl_parse | ( | mbedtls_x509_crl * | chain,
|  | const unsigned char * | buf,
|  | size_t | buflen
| ) |  |

Parse one or more CRLs and append them to the chained list.

Note
  Mutliple CRLs are accepted only if using PEM format

Parameters

  chain | points to the start of the chain
  buf | buffer holding the CRL data in PEM or DER format
  buflen | size of the buffer (including the terminating null byte for PEM data)

Returns
  0 if successful, or a specific X509 or PEM error code

## mbedtls_x509_crl_parse_der()

int mbedtls_x509_crl_parse_der | ( | mbedtls_x509_crl * | chain,
|  | const unsigned char * | buf,
|  | size_t | buflen
| ) |  |

Parse a DER-encoded CRL and append it to the chained list.

Parameters

  chain | points to the start of the chain
  buf | buffer holding the CRL data in DER format
  buflen | size of the buffer (including the terminating null byte for PEM data)

Returns
  0 if successful, or a specific X509 or PEM error code

## mbedtls_x509_crl_parse_file()

int mbedtls_x509_crl_parse_file | ( | mbedtls_x509_crl * | chain,
|  | const char * | path
| ) |  |

Load one or more CRLs and append them to the chained list.

Note
  Mutliple CRLs are accepted only if using PEM format

Parameters

  chain | points to the start of the chain
  path | filename to read the CRLs from (in PEM or DER encoding)

Returns
  0 if successful, or a specific X509 or PEM error code

## mbedtls_x509_crt_check_extended_key_usage()

int mbedtls_x509_crt_check_extended_key_usage | ( | const mbedtls_x509_crt * | crt,
|  | const char * | usage_oid,
|  | size_t | usage_len
| ) |  |

Check usage of certificate against extendedKeyUsage.

Parameters

  crt | Leaf certificate used.
  usage_oid | Intended usage (eg MBEDTLS_OID_SERVER_AUTH or MBEDTLS_OID_CLIENT_AUTH).
  usage_len | Length of usage_oid (eg given by MBEDTLS_OID_SIZE()).

Returns
  0 if this use of the certificate is allowed, MBEDTLS_ERR_X509_BAD_INPUT_DATA if not.

Note
  Usually only makes sense on leaf certificates.

## mbedtls_x509_crt_check_key_usage()

int mbedtls_x509_crt_check_key_usage | ( | const mbedtls_x509_crt * | crt,
|  | unsigned int | usage
| ) |  |

Check usage of certificate against keyUsage extension.

Parameters

  crt | Leaf certificate used.
  usage | Intended usage(s) (eg MBEDTLS_X509_KU_KEY_ENCIPHERMENT before using the certificate to perform an RSA key exchange).

Note
  Except for decipherOnly and encipherOnly, a bit set in the usage argument means this bit MUST be set in the certificate. For decipherOnly and encipherOnly, it means that bit MAY be set.

Returns
  0 is these uses of the certificate are allowed, MBEDTLS_ERR_X509_BAD_INPUT_DATA if the keyUsage extension is present but does not match the usage argument.

Note
  You should only call this function on leaf certificates, on (intermediate) CAs the keyUsage extension is automatically checked by `mbedtls_x509_crt_verify()`.

## mbedtls_x509_crt_free()

void mbedtls_x509_crt_free | ( | mbedtls_x509_crt * | crt | ) |

Unallocate all certificate data.

Parameters

  crt | Certificate chain to free

## mbedtls_x509_crt_info()

int mbedtls_x509_crt_info | ( | char * | buf,
|  | size_t | size,
|  | const char * | prefix,
|  | const mbedtls_x509_crt * | crt
| ) |  |

Returns an informational string about the certificate.

Parameters

  buf | Buffer to write to
  size | Maximum size of buffer
  prefix | A line prefix
  crt | The X509 certificate to represent

Returns
  The length of the string written (not including the terminated nul byte), or a negative error code.

## mbedtls_x509_crt_init()

void mbedtls_x509_crt_init | ( | mbedtls_x509_crt * | crt | ) |

Initialize a certificate (chain)

Parameters

  crt | Certificate chain to initialize

## mbedtls_x509_crt_is_revoked()

int mbedtls_x509_crt_is_revoked | ( | const mbedtls_x509_crt * | crt,
|  | const mbedtls_x509_crl * | crl
| ) |  |

Verify the certificate revocation status.

Parameters

  crt | a certificate to be verified
  crl | the CRL to verify against

Returns
  1 if the certificate is revoked, 0 otherwise

## mbedtls_x509_crt_parse()

int mbedtls_x509_crt_parse | ( | mbedtls_x509_crt * | chain,
|  | const unsigned char * | buf,
|  | size_t | buflen
| ) |  |

Parse one or more certificates and add them to the chained list. Parses permissively. If some certificates can be parsed, the result is the number of failed certificates it encountered. If none complete correctly, the first error is returned.

Parameters

  chain | points to the start of the chain
  buf | buffer holding the certificate data in PEM or DER format
  buflen | size of the buffer (including the terminating null byte for PEM data)

Returns
  0 if all certificates parsed successfully, a positive number if partly successful or a specific X509 or PEM error code

## mbedtls_x509_crt_parse_der()

int mbedtls_x509_crt_parse_der | ( | mbedtls_x509_crt * | chain,
|  | const unsigned char * | buf,
|  | size_t | buflen
| ) |  |

Parse a single DER formatted certificate and add it to the chained list.

Parameters

  chain | points to the start of the chain
  buf | buffer holding the certificate DER data
  buflen | size of the buffer

Returns
  0 if successful, or a specific X509 or PEM error code

## mbedtls_x509_crt_parse_file()

int mbedtls_x509_crt_parse_file | ( | mbedtls_x509_crt * | chain,
|  | const char * | path
| ) |  |

Load one or more certificates and add them to the chained list. Parses permissively. If some certificates can be parsed, the result is the number of failed certificates it encountered. If none complete correctly, the first error is returned.

Parameters

  chain | points to the start of the chain
  path | filename to read the certificates from

Returns
  0 if all certificates parsed successfully, a positive number if partly successful or a specific X509 or PEM error code

## mbedtls_x509_crt_parse_path()

int mbedtls_x509_crt_parse_path | ( | mbedtls_x509_crt * | chain,
|  | const char * | path
| ) |  |

Load one or more certificate files from a path and add them to the chained list. Parses permissively. If some certificates can be parsed, the result is the number of failed certificates it encountered. If none complete correctly, the first error is returned.

Parameters

  chain | points to the start of the chain
  path | directory / folder to read the certificate files from

Returns
  0 if all certificates parsed successfully, a positive number if partly successful or a specific X509 or PEM error code

## mbedtls_x509_crt_verify()

int mbedtls_x509_crt_verify | ( | mbedtls_x509_crt * | crt,
|  | mbedtls_x509_crt * | trust_ca,
|  | mbedtls_x509_crl * | ca_crl,
|  | const char * | cn,
|  | uint32_t * | flags,
|  | int(*)(void *, mbedtls_x509_crt *, int, uint32_t *) | f_vrfy,
|  | void * | p_vrfy
| ) |  |

Verify the certificate signature.

The verify callback is a user-supplied callback that can clear / modify / add flags for a certificate. If set, the verification callback is called for each certificate in the chain (from the trust-ca down to the presented crt). The parameters for the callback are: (void *parameter, mbedtls_x509_crt *crt, int certificate_depth, int *flags). With the flags representing current flags for that specific certificate and the certificate depth from the bottom (Peer cert depth = 0).

All flags left after returning from the callback are also returned to the application. The function should return 0 for anything (including invalid certificates) other than fatal error, as a non-zero return code immediately aborts the verification process. For fatal errors, a specific error code should be used (different from MBEDTLS_ERR_X509_CERT_VERIFY_FAILED which should not be returned at this point), or MBEDTLS_ERR_X509_FATAL_ERROR can be used if no better code is available.

Note
  In case verification failed, the results can be displayed using `mbedtls_x509_crt_verify_info()`
  Same as `mbedtls_x509_crt_verify_with_profile()` with the default security profile.
  It is your responsibility to provide up-to-date CRLs for all trusted CAs. If no CRL is provided for the CA that was used to sign the certificate, CRL verification is skipped silently, that is without setting any flag.

Parameters

  crt | a certificate (chain) to be verified
  trust_ca | the list of trusted CAs
  ca_crl | the list of CRLs for trusted CAs (see note above)
  cn | expected Common Name (can be set to NULL if the CN must not be verified)
  flags | result of the verification
  f_vrfy | verification function
  p_vrfy | verification parameter

Returns
  0 (and flags set to 0) if the chain was verified and valid, MBEDTLS_ERR_X509_CERT_VERIFY_FAILED if the chain was verified but found to be invalid, in which case *flags will have one or more MBEDTLS_X509_BADCERT_XXX or MBEDTLS_X509_BADCRL_XXX flags set, or another error (and flags set to 0xffffffff) in case of a fatal error encountered during the verification process.

## mbedtls_x509_crt_verify_info()

int mbedtls_x509_crt_verify_info | ( | char * | buf,
|  | size_t | size,
|  | const char * | prefix,
|  | uint32_t | flags
| ) |  |

Returns an informational string about the verification status of a certificate.

Parameters

  buf | Buffer to write to
  size | Maximum size of buffer
  prefix | A line prefix
  flags | Verification flags created by mbedtls_x509_crt_verify()

Returns
  The length of the string written (not including the terminated nul byte), or a negative error code.

## mbedtls_x509_crt_verify_with_profile()

int mbedtls_x509_crt_verify_with_profile | ( | mbedtls_x509_crt * | crt,
|  | mbedtls_x509_crt * | trust_ca,
|  | mbedtls_x509_crl * | ca_crl,
|  | const mbedtls_x509_crt_profile * | profile,
|  | const char * | cn,
|  | uint32_t * | flags,
|  | int(*)(void *, mbedtls_x509_crt *, int, uint32_t *) | f_vrfy,
|  | void * | p_vrfy
| ) |  |

Verify the certificate signature according to profile.

Note
  Same as `mbedtls_x509_crt_verify()`, but with explicit security profile.
  The restrictions on keys (RSA minimum size, allowed curves for ECDSA) apply to all certificates: trusted root, intermediate CAs if any, and end entity certificate.

Parameters

  crt | a certificate (chain) to be verified
  trust_ca | the list of trusted CAs
  ca_crl | the list of CRLs for trusted CAs
  profile | security profile for verification
  cn | expected Common Name (can be set to NULL if the CN must not be verified)
  flags | result of the verification
  f_vrfy | verification function
  p_vrfy | verification parameter

Returns
  0 if successful or MBEDTLS_ERR_X509_CERT_VERIFY_FAILED in which case *flags will have one or more MBEDTLS_X509_BADCERT_XXX or MBEDTLS_X509_BADCRL_XXX flags set, or another error in case of a fatal error encountered during the verification process.

## mbedtls_x509_csr_free()

void mbedtls_x509_csr_free | ( | mbedtls_x509_csr * | csr | ) |

Unallocate all CSR data.

Parameters

  csr | CSR to free

## mbedtls_x509_csr_info()

int mbedtls_x509_csr_info | ( | char * | buf,
|  | size_t | size,
|  | const char * | prefix,
|  | const mbedtls_x509_csr * | csr
| ) |  |

Returns an informational string about the CSR.

Parameters

  buf | Buffer to write to
  size | Maximum size of buffer
  prefix | A line prefix
  csr | The X509 CSR to represent

Returns
  The length of the string written (not including the terminated nul byte), or a negative error code.

## mbedtls_x509_csr_init()

void mbedtls_x509_csr_init | ( | mbedtls_x509_csr * | csr | ) |

Initialize a CSR.

Parameters

  csr | CSR to initialize

## mbedtls_x509_csr_parse()

int mbedtls_x509_csr_parse | ( | mbedtls_x509_csr * | csr,
|  | const unsigned char * | buf,
|  | size_t | buflen
| ) |  |

Load a Certificate Signing Request (CSR), DER or PEM format.

Note
  See notes for `mbedtls_x509_csr_parse_der()`

Parameters

  csr | CSR context to fill
  buf | buffer holding the CRL data
  buflen | size of the buffer (including the terminating null byte for PEM data)

Returns
  0 if successful, or a specific X509 or PEM error code

## mbedtls_x509_csr_parse_der()

int mbedtls_x509_csr_parse_der | ( | mbedtls_x509_csr * | csr,
|  | const unsigned char * | buf,
|  | size_t | buflen
| ) |  |

Load a Certificate Signing Request (CSR) in DER format.

Note
  CSR attributes (if any) are currently silently ignored.

Parameters

  csr | CSR context to fill
  buf | buffer holding the CRL data
  buflen | size of the buffer

Returns
  0 if successful, or a specific X509 error code

## mbedtls_x509_csr_parse_file()

int mbedtls_x509_csr_parse_file | ( | mbedtls_x509_csr * | csr,
|  | const char * | path
| ) |  |

Load a Certificate Signing Request (CSR)

Note
  See notes for `mbedtls_x509_csr_parse()`

Parameters

  csr | CSR context to fill
  path | filename to read the CSR from

Returns
  0 if successful, or a specific X509 or PEM error code

## Variable Documentation

## mbedtls_x509_crt_profile_default

const mbedtls_x509_crt_profile mbedtls_x509_crt_profile_default

Default security profile. Should provide a good balance between security and compatibility with current deployments.

## mbedtls_x509_crt_profile_next

const mbedtls_x509_crt_profile mbedtls_x509_crt_profile_next

Expected next default profile. Recommended for new deployments. Currently targets a 128-bit security level, except for RSA-2048.

## mbedtls_x509_crt_profile_suiteb

const mbedtls_x509_crt_profile mbedtls_x509_crt_profile_suiteb

NSA Suite B profile.